LeetCode-235. Lowest Common Ancestor of a Binary Search Tree

Given a binary search tree (BST), find the lowest common ancestor (LCA) of two given nodes in the BST.

According to the definition of LCA on Wikipedia: “The lowest common ancestor is defined between two nodes p and q as the lowest node in T that has both p and q as descendants (where we allow a node to be a descendant of itself).”

Given binary search tree:  root = [6,2,8,0,4,7,9,null,null,3,5]

        _______6______
       /              \
    ___2__          ___8__
   /      \        /      \
   0      _4       7       9
         /  \
         3   5

Example 1:

Input: root = [6,2,8,0,4,7,9,null,null,3,5], p = 2, q = 8
Output: 6
Explanation: The LCA of nodes 2 and 8 is 6.

Example 2:

Input: root = [6,2,8,0,4,7,9,null,null,3,5], p = 2, q = 4
Output: 2
Explanation: The LCA of nodes 2 and 4 is 2, since a node can be a descendant of itself according to the LCA definition.

Note:

  • All of the nodes' values will be unique.
  • p and q are different and both values will exist in the BST.

题目:寻找最近公共祖先。

思路:最近公共祖先的可能性分为三种,p,q全在左子树中;q,p全在右子树中;q,p一个在左子树一个在右子树。对于一二种的,递归调用左子树和右子树即可,对于第三种情况,p,q的最近祖先就是根节点,找不到比根节点更近的了。因此写出程序如下:

class Solution {
public:
    TreeNode* lowestCommonAncestor(TreeNode* root, TreeNode* p, TreeNode* q) {
		if(root->val<p->val&&root->val<q->val){
			return lowestCommonAncestor(root->right,TreeNone* p,TreeNode* q);
		} 
		else if(root->val>p->val&&root->val>q->val){
			return lowestCommonAncestor(root->left,TreeNone* p,TreeNode* q);
		} 
		else
			return root; 
    }
};

猜你喜欢

转载自blog.csdn.net/qq_29303759/article/details/81262004